## libminc 2.4.03

=== CMakeLists.txt ===
# CMakeFiles.txt for the libminc library
#
# Andrew Janke - a.janke@gmail.com
# Vladimir S. FONOV - vladimir.fonov@gmail.com

PROJECT(LIBMINC)

SET(LIBMINC_PACKAGE_VERSION_MAJOR 2)
SET(LIBMINC_PACKAGE_VERSION_MINOR 4)
SET(LIBMINC_PACKAGE_VERSION_PATCH 03)

SET(LIBMINC_SOVERSION "5.2.0")

SET(LIBMINC_PACKAGE "libminc")
SET(LIBMINC_PACKAGE_BUGREPORT "a.janke@gmail.com")

SET(LIBMINC_PACKAGE_NAME    "libminc")
SET(LIBMINC_PACKAGE_VERSION "${LIBMINC_PACKAGE_VERSION_MAJOR}.${LIBMINC_PACKAGE_VERSION_MINOR}.${LIBMINC_PACKAGE_VERSION_PATCH}")
SET(LIBMINC_PACKAGE_STRING  "${LIBMINC_PACKAGE_NAME} ${LIBMINC_PACKAGE_VERSION}")

INCLUDE(CTest)

ENABLE_TESTING()

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

IF( POLICY CMP0063 )
  CMAKE_POLICY(SET CMP0063 NEW)
ENDIF()

IF(MINC_TOOLKIT_BUILD)
  SET(LIBMINC_EXTERNALLY_CONFIGURED ON)
ENDIF(MINC_TOOLKIT_BUILD)

SET(LIBMINC_BUILD_V2 ON)

IF(NOT LIBMINC_EXTERNALLY_CONFIGURED)
  # Allowing User to configure parameters
  SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")

  SET(CPACK_GENERATOR TGZ)
  SET(CPACK_PACKAGE_VERSION_MAJOR ${LIBMINC_PACKAGE_VERSION_MAJOR})
  SET(CPACK_PACKAGE_VERSION_MINOR ${LIBMINC_PACKAGE_VERSION_MINOR})
  SET(CPACK_PACKAGE_VERSION_PATCH ${LIBMINC_PACKAGE_VERSION_PATCH})
  SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
  SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Medical Imaging library core IO")

  OPTION(LIBMINC_BUILD_SHARED_LIBS   "Build libminc with shared libraries."        OFF)


  OPTION(LIBMINC_MINC1_SUPPORT           "Support minc1 file format, requires NETCDF" OFF)
  OPTION(LIBMINC_BUILD_EZMINC_EXAMPLES   "Build EZminc examples" OFF)
  OPTION(LIBMINC_USE_SYSTEM_NIFTI        "Use system NIfTI-1 library" OFF)

  SET (LIBMINC_EXPORTED_TARGETS "LIBMINC-targets")
  SET (LIBMINC_INSTALL_BIN_DIR bin)
  SET (LIBMINC_INSTALL_LIB_DIR lib${LIB_SUFFIX})
  SET (LIBMINC_INSTALL_INCLUDE_DIR include)
  SET (LIBMINC_INSTALL_DATA_DIR share)

  IF(LIBMINC_MINC1_SUPPORT)
    FIND_PACKAGE(NETCDF REQUIRED)
  ENDIF(LIBMINC_MINC1_SUPPORT)

  # external packages
  FIND_PACKAGE(ZLIB REQUIRED)
  SET(HDF5_NO_FIND_PACKAGE_CONFIG_FILE ON)
  FIND_PACKAGE(HDF5 REQUIRED COMPONENTS C )
  
  IF (LIBMINC_USE_SYSTEM_NIFTI)
    FIND_PACKAGE(NIFTI)
  ELSE(LIBMINC_USE_SYSTEM_NIFTI)
    INCLUDE(ExternalProject)
    INCLUDE(BuildNIFTI)
    build_nifti(${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}/external)
  ENDIF(LIBMINC_USE_SYSTEM_NIFTI)
  
  SET(HAVE_ZLIB ON)
ELSE(NOT LIBMINC_EXTERNALLY_CONFIGURED)
  #TODO: set paths for HDF5 etc
ENDIF(NOT LIBMINC_EXTERNALLY_CONFIGURED)

IF(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH ON)
ENDIF(NOT DEFINED CMAKE_MACOSX_RPATH)

# Configure libminc
IF(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE SHARED)
  SET(LIBRARY_INSTALL LIBRARY)
ELSE(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE STATIC)
  SET(LIBRARY_INSTALL ARCHIVE)
ENDIF(LIBMINC_BUILD_SHARED_LIBS)

IF(CMAKE_BUILD_TYPE MATCHES Debug)
  SET(DEBUG "1")
ENDIF(CMAKE_BUILD_TYPE MATCHES Debug)

# add for building relocatable library
IF(UNIX)
  SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fPIC")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ENDIF(UNIX)

# check for prereqs
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckLibraryExists)

CHECK_FUNCTION_EXISTS(mkstemp  HAVE_MKSTEMP)
CHECK_FUNCTION_EXISTS(tmpnam   HAVE_TMPNAM)
CHECK_FUNCTION_EXISTS(tempnam  HAVE_TEMPNAM)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(popen    HAVE_POPEN)
CHECK_FUNCTION_EXISTS(fork     HAVE_WORKING_FORK)
CHECK_FUNCTION_EXISTS(vfork    HAVE_WORKING_VFORK)
CHECK_FUNCTION_EXISTS(fdopen   HAVE_FDOPEN)
CHECK_FUNCTION_EXISTS(strdup   HAVE_STRDUP)
CHECK_FUNCTION_EXISTS(getpwnam HAVE_GETPWNAM) 
CHECK_FUNCTION_EXISTS(select   HAVE_SELECT)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR) 
CHECK_FUNCTION_EXISTS(sysconf  HAVE_SYSCONF)
CHECK_FUNCTION_EXISTS(system   HAVE_SYSTEM)

if(NOT MSVC)
  set(CMAKE_REQUIRED_LIBRARIES m)
endif()

set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE=1 )

CHECK_SYMBOL_EXISTS(rint     "math.h"  HAVE_RINT)
CHECK_SYMBOL_EXISTS(copysign "math.h" HAVE_COPYSIGN)
CHECK_SYMBOL_EXISTS(round    "math.h" HAVE_ROUND)
unset(CMAKE_REQUIRED_LIBRARIES)
unset(CMAKE_REQUIRED_DEFINITIONS)


CHECK_FUNCTION_EXISTS(srand48   HAVE_SRAND48)
CHECK_FUNCTION_EXISTS(drand48   HAVE_DRAND48)
CHECK_FUNCTION_EXISTS(sleep     HAVE_SLEEP)

CHECK_FUNCTION_EXISTS(gettimeofday  HAVE_GETTIMEOFDAY)

CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME_RT)
IF(HAVE_CLOCK_GETTIME_RT)
  SET(RT_LIBRARY "rt")
  SET(HAVE_CLOCK_GETTIME ON)
ELSE(HAVE_CLOCK_GETTIME_RT)
  CHECK_SYMBOL_EXISTS(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
ENDIF(HAVE_CLOCK_GETTIME_RT)

INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(float.h     HAVE_FLOAT_H)
CHECK_INCLUDE_FILES(sys/dir.h   HAVE_SYS_DIR_H)
CHECK_INCLUDE_FILES(sys/ndir.h  HAVE_SYS_NDIR_H)
CHECK_INCLUDE_FILES(sys/stat.h  HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/wait.h  HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES(sys/time.h  HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES(time.h      HAVE_TIME_H)
CHECK_INCLUDE_FILES(values.h    HAVE_VALUES_H)
CHECK_INCLUDE_FILES(unistd.h    HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(dirent.h    HAVE_DIRENT_H)
CHECK_INCLUDE_FILES(memory.h    HAVE_MEMORY_H)
CHECK_INCLUDE_FILES(stdlib.h    HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(fcntl.h     HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(dlfcn.h     HAVE_DLFCN_H)
CHECK_INCLUDE_FILES(vfork.h     HAVE_VFORK_H)
CHECK_INCLUDE_FILES(inttypes.h  HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES(string.h    HAVE_STRING_H)
CHECK_INCLUDE_FILES(strings.h   HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(pwd.h       HAVE_PWD_H)
CHECK_INCLUDE_FILES(sys/select.h    HAVE_SYS_SELECT_H)


ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DMINC2=1)
IF(NOT APPLE)
ADD_DEFINITIONS(-D_XOPEN_SOURCE=500)
ENDIF(NOT APPLE)
# aliases
SET(VERSION "${LIBMINC_EXTERNAL_LIB_PREFIX}${LIBMINC_PACKAGE_VERSION}")
SET(HAVE_MINC1 ${LIBMINC_MINC1_SUPPORT})
SET(HAVE_MINC2 ON)
SET(MINC2 "1")

IF(LIBMINC_MINC1_SUPPORT)
 ADD_DEFINITIONS(-DHAVE_MINC1=1)
ENDIF(LIBMINC_MINC1_SUPPORT)

IF(LIBMINC_BUILD_EZMINC)
  set(LIBMINC_INCLUDE_DIRS_CONFIG    
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
  )
  INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
   )
ENDIF(LIBMINC_BUILD_EZMINC)

IF(NIFTI_FOUND)
    SET(LIBMINC_NIFTI_SUPPORT ON)
    SET(LIBMINC_NIFTI_SOURCES
      volume_io/Volumes/input_nifti.c
      volume_io/Volumes/input_mgh.c
      volume_io/Volumes/input_nrrd.c
    )
ENDIF(NIFTI_FOUND)

# config files for build
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

# others
#CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/epm-header.in ${CMAKE_CURRENT_BINARY_DIR}/epm-header)

# set the master INCLUDE directories
INCLUDE_DIRECTORIES(
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}/libcommon
   ${CMAKE_CURRENT_SOURCE_DIR}/libsrc2
   ${CMAKE_CURRENT_SOURCE_DIR}/libsrc
   ${CMAKE_CURRENT_SOURCE_DIR}/volume_io/Include
   ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
   ${HDF5_INCLUDE_DIRS}
   )

IF(LIBMINC_NIFTI_SUPPORT)
    INCLUDE_DIRECTORIES(
        ${NIFTI_INCLUDE_DIR}
    )
ENDIF(LIBMINC_NIFTI_SUPPORT)

SET(minc_common_SRCS
  libcommon/minc2_error.c
  libcommon/minc_config.c
  libcommon/minc_error.c
  libcommon/ParseArgv.c
  libcommon/read_file_names.c
  libcommon/restructure.c
  libcommon/time_stamp.c
)

SET(minc_common_HEADERS
  libcommon/minc2_error.h
  libcommon/minc_config.h
  libcommon/minc_error.h
  libcommon/ParseArgv.h
  libcommon/read_file_names.h
  libcommon/restructure.h
  libcommon/time_stamp.h
  libcommon/minc_common_defs.h
  volume_io/Include/volume_io.h # VF: WTF?
)

SET(minc1_LIB_SRCS
   libsrc/dim_conversion.c
   libsrc/image_conversion.c
   libsrc/minc_convenience.c
   libsrc/nd_loop.c
   libsrc/netcdf_convenience.c
   libsrc/value_conversion.c
   libsrc/voxel_loop.c
   libsrc/hdf_convenience.c
   libsrc/minc_compat.c
   libsrc/minc_simple.c
   libsrc/minc_format_convert.c
   )

SET(minc1_HEADERS
  libsrc/minc.h 
  libsrc/voxel_loop.h 
  libsrc/nd_loop.h
  libsrc/minc_compat.h
  libsrc/minc_simple.h
  libsrc/minc_format_convert.h
)

SET(minc2_LIB_SRCS
   libsrc2/convert.c
   libsrc2/datatype.c
   libsrc2/dimension.c
   libsrc2/free.c
   libsrc2/grpattr.c
   libsrc2/hyper.c
   libsrc2/label.c
   libsrc2/m2util.c
   libsrc2/record.c
   libsrc2/slice.c
   libsrc2/valid.c
   libsrc2/volprops.c
   libsrc2/volume.c
   )

SET(minc2_HEADERS
  libsrc2/minc2.h
  libsrc2/minc2_defs.h 
  libsrc2/minc2_structs.h 
  libsrc2/minc2_api.h 
)

# volume_io2
SET(volume_io_LIB_SRCS
   volume_io/Geometry/colour.c
   volume_io/Geometry/colour_def.c
   volume_io/Geometry/gaussian.c
   volume_io/Geometry/inverse.c
   volume_io/Geometry/newton.c
   volume_io/Geometry/points.c
   volume_io/Geometry/splines.c
   volume_io/Geometry/tensors.c
   volume_io/Geometry/transforms.c
   volume_io/MNI_formats/gen_xf_io.c
   volume_io/MNI_formats/gen_xfs.c
   volume_io/MNI_formats/grid_transforms.c
   volume_io/MNI_formats/mni_io.c
   volume_io/MNI_formats/tag_points.c
   volume_io/MNI_formats/thin_plate_spline.c
   volume_io/Prog_utils/alloc.c
   volume_io/Prog_utils/alloc_check.c
   volume_io/Prog_utils/arrays.c
   volume_io/Prog_utils/files.c
   volume_io/Prog_utils/print.c
   volume_io/Prog_utils/progress.c
   volume_io/Prog_utils/string.c
   volume_io/Prog_utils/time.c
   volume_io/Volumes/evaluate.c
   volume_io/Volumes/get_hyperslab.c
   volume_io/Volumes/input_free.c
   volume_io/Volumes/input_mnc.c
   volume_io/Volumes/input_volume.c
   volume_io/Volumes/multidim_arrays.c
   volume_io/Volumes/output_mnc.c
   volume_io/Volumes/output_volume.c
   volume_io/Volumes/set_hyperslab.c
   volume_io/Volumes/volume_cache.c
   volume_io/Volumes/volumes.c
   volume_io/Volumes/input_mnc2.c
   volume_io/Volumes/output_mnc2.c
)

IF(LIBMINC_NIFTI_SUPPORT)
    SET(volume_io_LIB_SRCS 
        ${volume_io_LIB_SRCS}
        ${LIBMINC_NIFTI_SOURCES}
    )
ENDIF(LIBMINC_NIFTI_SUPPORT)


SET(volume_io_HEADERS
    volume_io/Include/volume_io/alloc.h
    volume_io/Include/volume_io/arrays.h 
    volume_io/Include/volume_io/basic.h 
    volume_io/Include/volume_io/def_math.h 
    volume_io/Include/volume_io/files.h 
    volume_io/Include/volume_io/geom_structs.h 
    volume_io/Include/volume_io/geometry.h 
    volume_io/Include/volume_io/multidim.h 
    volume_io/Include/volume_io/progress.h 
    volume_io/Include/volume_io/string_funcs.h 
    volume_io/Include/volume_io/system_dependent.h 
    volume_io/Include/volume_io/transforms.h 
    volume_io/Include/volume_io/vol_io_prototypes.h 
    volume_io/Include/volume_io/volume.h 
    volume_io/Include/volume_io/volume_cache.h
)

SET(LIBMINC_LIBRARY   ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)

# a hack for APPLE
IF(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2_static)
ELSE(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_LIBRARY})
ENDIF(LIBMINC_BUILD_SHARED_LIBS)

IF(LIBMINC_NIFTI_SUPPORT)
    SET(NIFTI_LIBRARIES 
        ${NIFTI_LIBRARY} ${ZNZ_LIBRARY}
    )
ELSE(LIBMINC_NIFTI_SUPPORT)
    SET(NIFTI_LIBRARIES )
ENDIF(LIBMINC_NIFTI_SUPPORT)


SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARY} ${HDF5_LIBRARIES} ${NIFTI_LIBRARIES} ${ZLIB_LIBRARY})
SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_LIBRARY_STATIC} ${HDF5_LIBRARIES} ${NIFTI_LIBRARIES} ${ZLIB_LIBRARY})

IF(UNIX)
  SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARIES} m dl ${RT_LIBRARY})
  SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_STATIC_LIBRARIES} m dl  ${RT_LIBRARY})
ENDIF(UNIX)

SET(minc_LIB_SRCS ${minc2_LIB_SRCS} ${minc_common_SRCS})
SET(minc_HEADERS  ${minc2_HEADERS} ${minc_common_HEADERS})

IF(LIBMINC_MINC1_SUPPORT)
  SET(minc_HEADERS  ${minc_HEADERS}  ${minc1_HEADERS})
  SET(minc_LIB_SRCS ${minc_LIB_SRCS} ${minc1_LIB_SRCS})
ENDIF(LIBMINC_MINC1_SUPPORT)


# Keep this variable for compatibility
SET(VOLUME_IO_LIBRARY  ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)

=== testdir/CMakeLists.txt ===
LINK_LIBRARIES(${LIBMINC_LIBRARIES})

MACRO(minc_test cmd)
  # minc 1 version
  IF(HAVE_MINC1)
    ADD_TEST(${cmd}-1 ${CMAKE_CURRENT_SOURCE_DIR}/run_test_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/${cmd} ${CMAKE_CURRENT_SOURCE_DIR}/${cmd}.out)
  ENDIF(HAVE_MINC1)
  
  ADD_TEST(${cmd}-2 ${CMAKE_CURRENT_SOURCE_DIR}/run_test2_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/${cmd} ${CMAKE_CURRENT_SOURCE_DIR}/${cmd}.out)
  
  IF(MINC_TEST_ENVIRONMENT)
   set_tests_properties( ${cmd}-1 PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
  ENDIF(MINC_TEST_ENVIRONMENT)
  
  IF(MINC_TEST_ENVIRONMENT)
   set_tests_properties( ${cmd}-2 PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
  ENDIF(MINC_TEST_ENVIRONMENT)
ENDMACRO(minc_test)

MACRO(add_minc_test name cmd)

  ADD_TEST( ${name}
      ${cmd} ${ARGV2} ${ARGV3} ${ARGV4} ${ARGV5} ${ARGV6} ${ARGV7} ${ARGV8} ${ARGV9} ${ARGV10} ${ARGV11}
        ${ARGV12} ${ARGV13} ${ARGV14} ${ARGV15} ${ARGV16} ${ARGV17} ${ARGV18} ${ARGV19} ${ARGV20} ${ARGV21} ${ARGV22}
        ${ARGV23} ${ARGV24} ${ARGV25} ${ARGV26}
   )
   
   IF(MINC_TEST_ENVIRONMENT)
    set_tests_properties( ${name} PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
   ENDIF(MINC_TEST_ENVIRONMENT)
   
ENDMACRO(add_minc_test)


IF(LIBMINC_MINC1_SUPPORT)

  ADD_EXECUTABLE(minc_tst minc.c)
  ADD_EXECUTABLE(icv icv.c)
  ADD_EXECUTABLE(icv_vec icv_vec.c)
  ADD_EXECUTABLE(icv_dim1 icv_dim1.c)
  ADD_EXECUTABLE(icv_dim icv_dim.c)
  ADD_EXECUTABLE(icv_fillvalue icv_fillvalue.c)
  ADD_EXECUTABLE(icv_range icv_range.c)
  ADD_EXECUTABLE(mincapi mincapi.c)
  ADD_EXECUTABLE(minc_types minc_types.c)
  ADD_EXECUTABLE(test_mconv test_mconv.c)
  ADD_EXECUTABLE(minc_long_attr minc_long_attr.c)
  ADD_EXECUTABLE(minc_conversion minc_conversion.c)

  # running tests
  minc_test(minc_types)
  minc_test(icv_dim1)
  minc_test(icv_dim)
  minc_test(icv_fillvalue)
  minc_test(icv_range)

  add_minc_test(arg_parse ${CMAKE_CURRENT_SOURCE_DIR}/run_test_arg_parse_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/test_arg_parse)
  add_minc_test(icv icv)
  add_minc_test(icv_vec icv_vec)
  add_minc_test(minc minc_tst)
  add_minc_test(mincapi mincapi)
  add_minc_test(test_mconv test_mconv)
  add_minc_test(minc_long_attr_10k minc_long_attr 10000)
  add_minc_test(minc_long_attr_100k minc_long_attr 100000)
  add_minc_test(minc_long_attr_1m minc_long_attr 1000000)
  add_minc_test(minc_conversion minc_conversion)
ENDIF(LIBMINC_MINC1_SUPPORT)

# Volume IO tests
ADD_EXECUTABLE(volume_test volume_test.c)
ADD_TEST(volume_test-1 volume_test)

ADD_EXECUTABLE(multidim_test multidim_test.c)
ADD_TEST(volume_multidim_test multidim_test)

ADD_EXECUTABLE(test_xfm   vio_xfm_test/test-xfm.c)
TARGET_LINK_LIBRARIES(test_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(copy_xfm   vio_xfm_test/copy-xfm.c)
TARGET_LINK_LIBRARIES(copy_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(create_grid_xfm create_grid_xfm.c)
TARGET_LINK_LIBRARIES(create_grid_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(verify_xfm   vio_xfm_test/verify_xfm.c)
TARGET_LINK_LIBRARIES(verify_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

#ADD_TEST(create_grid_xfm create_grid_xfm)
#ADD_TEST(test_speed test_speed)


add_minc_test(test_xfm_1 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t1.xfm)
add_minc_test(test_xfm_2 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t2.xfm)
add_minc_test(test_xfm_3 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm 0.9)

add_minc_test(copy_xfm copy_xfm ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm ${CMAKE_CURRENT_BINARY_DIR}/t3_copy.xfm)

add_minc_test(verify_xfm_1 verify_xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/random2 
 1e-6)

add_minc_test(verify_xfm_float verify_xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_float.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
 1e-9)

add_minc_test(verify_xfm_short verify_xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_short.xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
  1e-4)
  
add_minc_test(verify_xfm_byte verify_xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_byte.xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
  1e-1) 

add_minc_test(verify_xfm_2 verify_xfm 
 ${CMAKE_CURRENT_BINARY_DIR}/t3_copy.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/random2
 1e-3)

set_property(TEST verify_xfm_2 APPEND PROPERTY DEPENDS copy_xfm)


#common tests
ADD_EXECUTABLE(test_arg_parse test_arg_parse.c)
add_minc_test(test_arg_parse test_arg_parse)


#MINC2 tests
ADD_EXECUTABLE(minc2-convert-test minc2-convert-test.c)
ADD_EXECUTABLE(minc2-create-test-images-2 minc2-create-test-images-2.c)
ADD_EXECUTABLE(minc2-create-test-images minc2-create-test-images.c)
ADD_EXECUTABLE(minc2-datatype-test minc2-datatype-test.c)
ADD_EXECUTABLE(minc2-large-attribute minc2-large-attribute.c)
ADD_EXECUTABLE(minc2-dimension-test minc2-dimension-test.c)
ADD_EXECUTABLE(minc2-full-test minc2-full-test.c)
ADD_EXECUTABLE(minc2-grpattr-test minc2-grpattr-test.c)
ADD_EXECUTABLE(minc2-hyper-test-2 minc2-hyper-test-2.c)
ADD_EXECUTABLE(minc2-hyper-test minc2-hyper-test.c)
ADD_EXECUTABLE(minc2-label-test minc2-label-test.c)
#ADD_EXECUTABLE(minc2-m2stats minc2-m2stats.c)
ADD_EXECUTABLE(minc2-multires-test minc2-multires-test.c)
ADD_EXECUTABLE(minc2-record-test minc2-record-test.c)
ADD_EXECUTABLE(minc2-slice-test minc2-slice-test.c)
ADD_EXECUTABLE(minc2-valid-test minc2-valid-test.c)
ADD_EXECUTABLE(minc2-vector_dimension-test minc2-vector_dimension-test.c)
ADD_EXECUTABLE(minc2-volprops-test minc2-volprops-test.c)
ADD_EXECUTABLE(minc2-read-rgb minc2-read-rgb.c)
ADD_EXECUTABLE(minc2-read-metadata minc2-read-metadata.c)

ADD_EXECUTABLE(minc2-leak-test minc2-leak-test.c)

add_minc_test(minc2-convert-test          minc2-convert-test)
add_minc_test(minc2-create-test-images    minc2-create-test-images 
                                          ${CMAKE_CURRENT_BINARY_DIR}/2D_minc2.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/4D_minc2.mnc)

add_minc_test(minc2-create-test-images-2  minc2-create-test-images-2
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_int.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_float.mnc 
                                          )

add_minc_test(minc2-large-attribute-10k   minc2-large-attribute 10000)
add_minc_test(minc2-large-attribute-100k  minc2-large-attribute 100000)
add_minc_test(minc2-large-attribute-1m    minc2-large-attribute 1000000)

add_minc_test(minc2-datatype-test         minc2-datatype-test  
                                          ${CMAKE_CURRENT_BINARY_DIR}/datatype_minc2.mnc)
                                          
add_minc_test(minc2-dimension-test        minc2-dimension-test)
add_minc_test(minc2-full-test             minc2-full-test)
add_minc_test(minc2-grpattr-test          minc2-grpattr-test)
add_minc_test(minc2-hyper-test-2          minc2-hyper-test-2)
add_minc_test(minc2-hyper-test            minc2-hyper-test)
add_minc_test(minc2-label-test            minc2-label-test)
#add_minc_test(minc2-m2stats minc2-m2stats)
add_minc_test(minc2-multires-test         minc2-multires-test)
add_minc_test(minc2-record-test           minc2-record-test)


add_minc_test(minc2-slice-test            minc2-slice-test 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_int.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_float.mnc
                                          )
                                          

add_minc_test(minc2-valid-test            minc2-valid-test
                                          ${CMAKE_CURRENT_BINARY_DIR}/2D_minc2.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_int.mnc 
                                          ${CMAKE_CURRENT_BINARY_DIR}/3D_minc2_float.mnc
                                          ${CMAKE_CURRENT_BINARY_DIR}/4D_minc2.mnc
)
add_minc_test(minc2-vector_dimension-test minc2-vector_dimension-test)
add_minc_test(minc2-volprops-test         minc2-volprops-test)

add_minc_test(minc2-leak-test             minc2-leak-test)


set_property(TEST minc2-slice-test APPEND PROPERTY DEPENDS minc2-create-test-images) 
set_property(TEST minc2-slice-test APPEND PROPERTY DEPENDS minc2-create-test-images-2) 
set_property(TEST minc2-valid-test APPEND PROPERTY DEPENDS minc2-create-test-images) 
set_property(TEST minc2-valid-test APPEND PROPERTY DEPENDS minc2-create-test-images-2)

=== debian/changelog ===
libminc (2.4.03-3) unstable; urgency=medium

  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 18 Nov 2020 09:07:03 +0100

libminc (2.4.03-2) unstable; urgency=medium

  * Team upload
  * d/: Install cmake file in the correct location Closes: #907553
        (locutusofborg)

 -- Gert Wollny <gewo@debian.org>  Thu, 30 Aug 2018 18:44:55 +0200

libminc (2.4.03-1) unstable; urgency=medium

  * re-upload to sid

 -- Gert Wollny <gewo@debian.org>  Sun, 26 Aug 2018 19:10:28 +0200

libminc (2.4.03-1~exp3) experimental; urgency=medium

  * Team upload
  * d/p/disable: avoid FTBFS on powerpc

 -- Gert Wollny <gewo@debian.org>  Thu, 16 Aug 2018 17:46:26 +0200

libminc (2.4.03-1~exp2) experimental; urgency=medium

  * d/p/initialize: Fix FTBFS on armhf and possibly other archs

 -- Gert Wollny <gewo@debian.org>  Sun, 03 Jun 2018 10:40:12 +0200

libminc (2.4.03-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 2.4.03
  * d/p: remove patches resolved upstream
  * d/rules: Enable system nifti from build rules
  * d/control: cme fix dpkg: Update urls and standard (no changes needed)
  * d/rules, *.install: Move to use install files
  * d/p/remove-rpath: Don't set rpath when installing
  * Correct *.cmake install location
  * d/rules: add -ffloat-store in i386 build to pass tests
  * d/copyright: Add some contributor names that were missing

 -- Gert Wollny <gewo@debian.org>  Sat, 19 May 2018 22:12:40 +0200

=== debian/control ===
Source: libminc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               cmake,
               libnetcdf-dev,
               libnifti-dev,
               zlib1g-dev,
               libhdf5-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libminc
Vcs-Git: https://salsa.debian.org/med-team/libminc.git
Homepage: https://github.com/BIC-MNI/libminc
Rules-Requires-Root: no

Package: libminc2-5.2.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: MNI medical image format library
 This package contains the libraries libminc2 and libminc_io.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format.
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libminc2-5.2.0 (= ${binary:Version}),
         libnetcdf-dev,
         libhdf5-dev
Conflicts: libminc0-dev
Replaces: libminc0-dev
Description: MNI medical image format development environment
 This package contains the library and headers for libminc2 and
 libminc_io.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format.
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

=== debian/watch ===
version=4

opts=uversionmangle=s/-/./g;s/^?(libminc|release)[-.]*// \
   https://github.com/BIC-MNI/libminc/releases .*/archive/?(libminc|release)-(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## libminc 2.4.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,9 @@
 
 SET(LIBMINC_PACKAGE_VERSION_MAJOR 2)
 SET(LIBMINC_PACKAGE_VERSION_MINOR 4)
-SET(LIBMINC_PACKAGE_VERSION_PATCH 03)
-
-SET(LIBMINC_SOVERSION "5.2.0")
+SET(LIBMINC_PACKAGE_VERSION_PATCH 05)
+
+SET(LIBMINC_SOVERSION "5.3.0")
 
 SET(LIBMINC_PACKAGE "libminc")
 SET(LIBMINC_PACKAGE_BUGREPORT "a.janke@gmail.com")
@@ -22,7 +22,7 @@
 
 ENABLE_TESTING()
 
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.6)
 
 IF( POLICY CMP0063 )
   CMAKE_POLICY(SET CMP0063 NEW)
@@ -49,7 +49,9 @@
 
 
   OPTION(LIBMINC_MINC1_SUPPORT           "Support minc1 file format, requires NETCDF" OFF)
+  OPTION(LIBMINC_BUILD_EZMINC            "Build C++ EMINC library based on libminc1" ON)
   OPTION(LIBMINC_BUILD_EZMINC_EXAMPLES   "Build EZminc examples" OFF)
+  OPTION(LIBMINC_USE_NIFTI               "Build with NIfTI support" OFF)
   OPTION(LIBMINC_USE_SYSTEM_NIFTI        "Use system NIfTI-1 library" OFF)
 
   SET (LIBMINC_EXPORTED_TARGETS "LIBMINC-targets")
@@ -67,6 +69,7 @@
   SET(HDF5_NO_FIND_PACKAGE_CONFIG_FILE ON)
   FIND_PACKAGE(HDF5 REQUIRED COMPONENTS C )
   
+  IF(LIBMINC_USE_NIFTI)
   IF (LIBMINC_USE_SYSTEM_NIFTI)
     FIND_PACKAGE(NIFTI)
   ELSE(LIBMINC_USE_SYSTEM_NIFTI)
@@ -74,6 +77,9 @@
     INCLUDE(BuildNIFTI)
     build_nifti(${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}/external)
   ENDIF(LIBMINC_USE_SYSTEM_NIFTI)
+  ELSE()
+  SET(NIFTI_FOUND OFF)
+  ENDIF()
   
   SET(HAVE_ZLIB ON)
 ELSE(NOT LIBMINC_EXTERNALLY_CONFIGURED)
@@ -129,9 +135,10 @@
 
 set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE=1 )
 
-CHECK_SYMBOL_EXISTS(rint     "math.h"  HAVE_RINT)
+CHECK_SYMBOL_EXISTS(rint     "math.h" HAVE_RINT)
 CHECK_SYMBOL_EXISTS(copysign "math.h" HAVE_COPYSIGN)
 CHECK_SYMBOL_EXISTS(round    "math.h" HAVE_ROUND)
+CHECK_SYMBOL_EXISTS(fabsf    "math.h" HAVE_FABSF)
 unset(CMAKE_REQUIRED_LIBRARIES)
 unset(CMAKE_REQUIRED_DEFINITIONS)
 
@@ -143,11 +150,27 @@
 CHECK_FUNCTION_EXISTS(gettimeofday  HAVE_GETTIMEOFDAY)
 
 CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME_RT)
+
 IF(HAVE_CLOCK_GETTIME_RT)
   SET(RT_LIBRARY "rt")
   SET(HAVE_CLOCK_GETTIME ON)
 ELSE(HAVE_CLOCK_GETTIME_RT)
-  CHECK_SYMBOL_EXISTS(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
+  # first check if the function is defined in header
+  CHECK_SYMBOL_EXISTS(clock_gettime "time.h" HAVE_CLOCK_GETTIME_SYMBOL)
+  # then check that it's available
+  IF(HAVE_CLOCK_GETTIME_SYMBOL)
+    TRY_RUN(HAVE_CLOCK_GETTIME_RUN HAVE_CLOCK_GETTIME_COMP
+            ${CMAKE_CURRENT_BINARY_DIR}
+            ${CMAKE_CURRENT_SOURCE_DIR}/check_clock_gettime.c
+            )
+    IF(HAVE_CLOCK_GETTIME_RUN EQUAL 0 AND HAVE_CLOCK_GETTIME_COMP)
+      SET(HAVE_CLOCK_GETTIME ON)
+    ELSE()
+      SET(HAVE_CLOCK_GETTIME OFF)
+    ENDIF()
+  ENDIF()
+
+
 ENDIF(HAVE_CLOCK_GETTIME_RT)
 
 INCLUDE(CheckIncludeFiles)
@@ -221,9 +244,12 @@
    ${CMAKE_CURRENT_SOURCE_DIR}/libsrc2
    ${CMAKE_CURRENT_SOURCE_DIR}/libsrc
    ${CMAKE_CURRENT_SOURCE_DIR}/volume_io/Include
-   ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
    ${HDF5_INCLUDE_DIRS}
    )
+
+IF(LIBMINC_BUILD_EZMINC AND LIBMINC_MINC1_SUPPORT)
+  INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/ezminc )
+ENDIF()
 
 IF(LIBMINC_NIFTI_SUPPORT)
     INCLUDE_DIRECTORIES(
@@ -365,11 +391,11 @@
     volume_io/Include/volume_io/volume_cache.h
 )
 
-SET(LIBMINC_LIBRARY   ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)
+SET(LIBMINC_LIBRARY   minc2)
 
 # a hack for APPLE
 IF(LIBMINC_BUILD_SHARED_LIBS)
-  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2_static)
+  SET(LIBMINC_LIBRARY_STATIC minc2_static)
 ELSE(LIBMINC_BUILD_SHARED_LIBS)
   SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_LIBRARY})
 ENDIF(LIBMINC_BUILD_SHARED_LIBS)
@@ -378,27 +404,4 @@
     SET(NIFTI_LIBRARIES 
         ${NIFTI_LIBRARY} ${ZNZ_LIBRARY}
     )
-ELSE(LIBMINC_NIFTI_SUPPORT)
-    SET(NIFTI_LIBRARIES )
-ENDIF(LIBMINC_NIFTI_SUPPORT)
-
-
-SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARY} ${HDF5_LIBRARIES} ${NIFTI_LIBRARIES} ${ZLIB_LIBRARY})
-SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_LIBRARY_STATIC} ${HDF5_LIBRARIES} ${NIFTI_LIBRARIES} ${ZLIB_LIBRARY})
-
-IF(UNIX)
-  SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARIES} m dl ${RT_LIBRARY})
-  SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_STATIC_LIBRARIES} m dl  ${RT_LIBRARY})
-ENDIF(UNIX)
-
-SET(minc_LIB_SRCS ${minc2_LIB_SRCS} ${minc_common_SRCS})
-SET(minc_HEADERS  ${minc2_HEADERS} ${minc_common_HEADERS})
-
-IF(LIBMINC_MINC1_SUPPORT)
-  SET(minc_HEADERS  ${minc_HEADERS}  ${minc1_HEADERS})
-  SET(minc_LIB_SRCS ${minc_LIB_SRCS} ${minc1_LIB_SRCS})
-ENDIF(LIBMINC_MINC1_SUPPORT)
-
-
-# Keep this variable for compatibility
-SET(VOLUME_IO_LIBRARY  ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)
+    get_filename_component(NIFTI_LIBRARY_NAME "${NIFTI_LIBRARY}" NAME)

=== testdir/CMakeLists.txt ===
--- 
+++ 
@@ -151,6 +151,7 @@
 ADD_EXECUTABLE(minc2-read-metadata minc2-read-metadata.c)
 
 ADD_EXECUTABLE(minc2-leak-test minc2-leak-test.c)
+ADD_EXECUTABLE(minc2-float-voxel-test minc2-float-voxel-test.c)
 
 add_minc_test(minc2-convert-test          minc2-convert-test)
 add_minc_test(minc2-create-test-images    minc2-create-test-images 
@@ -200,6 +201,9 @@
 
 add_minc_test(minc2-leak-test             minc2-leak-test)
 
+add_minc_test(minc2-float-voxel-test      minc2-float-voxel-test
+                                          ${CMAKE_CURRENT_BINARY_DIR}/test-dbl.mnc
+                                          )
 
 set_property(TEST minc2-slice-test APPEND PROPERTY DEPENDS minc2-create-test-images) 
 set_property(TEST minc2-slice-test APPEND PROPERTY DEPENDS minc2-create-test-images-2)

=== debian/changelog ===
libminc (2.4.05-4) unstable; urgency=medium

  [ Steve Robbins ]
  * [d8373de] Patch to properly remove RPATH.

 -- Steve M. Robbins <smr@debian.org>  Thu, 01 Sep 2022 22:37:37 -0500

libminc (2.4.05-3) unstable; urgency=medium

  [ Steve Robbins ]
  * [5e0279b] Restore fix for LIBMINC_USE_FILE_CONFIG, inadvertently removed. 
    Patches generated using gbp patch-queue, so the preamble changed for others.

 -- Steve M. Robbins <smr@debian.org>  Thu, 01 Sep 2022 21:22:42 -0500

libminc (2.4.05-2) unstable; urgency=medium

  * Useless revision for testing migration.

 -- Steve M. Robbins <smr@debian.org>  Tue, 23 Aug 2022 21:46:56 -0500

libminc (2.4.05-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Drop unneeded debian/.gitlab-ci.yml
  * Add symbols file

  [ Steve Robbins ]
  * [055ad76] Set package name to match SOVERSION.

 -- Steve M. Robbins <smr@debian.org>  Sun, 21 Aug 2022 11:48:32 -0500

libminc (2.4.03-5) unstable; urgency=medium

  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Thu, 27 Jan 2022 21:16:56 +0100

libminc (2.4.03-4) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 09:04:35 +0200

=== debian/control ===
--- 
+++ 
@@ -11,13 +11,13 @@
                libnifti-dev,
                zlib1g-dev,
                libhdf5-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/libminc
 Vcs-Git: https://salsa.debian.org/med-team/libminc.git
 Homepage: https://github.com/BIC-MNI/libminc
 Rules-Requires-Root: no
 
-Package: libminc2-5.2.0
+Package: libminc2-5.3.0
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -43,11 +43,12 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
-         libminc2-5.2.0 (= ${binary:Version}),
+         libminc2-5.3.0 (= ${binary:Version}),
          libnetcdf-dev,
          libhdf5-dev
 Conflicts: libminc0-dev
 Replaces: libminc0-dev
+Multi-Arch: same
 Description: MNI medical image format development environment
  This package contains the library and headers for libminc2 and
  libminc_io.

## libminc 2.4.06

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,12 +7,12 @@
 
 SET(LIBMINC_PACKAGE_VERSION_MAJOR 2)
 SET(LIBMINC_PACKAGE_VERSION_MINOR 4)
-SET(LIBMINC_PACKAGE_VERSION_PATCH 05)
+SET(LIBMINC_PACKAGE_VERSION_PATCH 06)
 
 SET(LIBMINC_SOVERSION "5.3.0")
 
 SET(LIBMINC_PACKAGE "libminc")
-SET(LIBMINC_PACKAGE_BUGREPORT "a.janke@gmail.com")
+SET(LIBMINC_PACKAGE_BUGREPORT "vladimir.fonov@gmail.com")
 
 SET(LIBMINC_PACKAGE_NAME    "libminc")
 SET(LIBMINC_PACKAGE_VERSION "${LIBMINC_PACKAGE_VERSION_MAJOR}.${LIBMINC_PACKAGE_VERSION_MINOR}.${LIBMINC_PACKAGE_VERSION_PATCH}")
@@ -53,6 +53,8 @@
   OPTION(LIBMINC_BUILD_EZMINC_EXAMPLES   "Build EZminc examples" OFF)
   OPTION(LIBMINC_USE_NIFTI               "Build with NIfTI support" OFF)
   OPTION(LIBMINC_USE_SYSTEM_NIFTI        "Use system NIfTI-1 library" OFF)
+
+  OPTION(LIBMINC_USE_ASAN                "Build with Address Sanitizer" OFF)
 
   SET (LIBMINC_EXPORTED_TARGETS "LIBMINC-targets")
   SET (LIBMINC_INSTALL_BIN_DIR bin)
@@ -108,6 +110,13 @@
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fPIC")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 ENDIF(UNIX)
+
+
+IF(LIBMINC_USE_ASAN)
+  add_compile_options(-fno-omit-frame-pointer -fsanitize=address)
+  add_link_options(-fno-omit-frame-pointer -fsanitize=address)
+ENDIF(LIBMINC_USE_ASAN)
+
 
 # check for prereqs
 INCLUDE(CheckFunctionExists)
@@ -397,11 +406,3 @@
 IF(LIBMINC_BUILD_SHARED_LIBS)
   SET(LIBMINC_LIBRARY_STATIC minc2_static)
 ELSE(LIBMINC_BUILD_SHARED_LIBS)
-  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_LIBRARY})
-ENDIF(LIBMINC_BUILD_SHARED_LIBS)
-
-IF(LIBMINC_NIFTI_SUPPORT)
-    SET(NIFTI_LIBRARIES 
-        ${NIFTI_LIBRARY} ${ZNZ_LIBRARY}
-    )
-    get_filename_component(NIFTI_LIBRARY_NAME "${NIFTI_LIBRARY}" NAME)

=== ezminc/examples/CMakeLists.txt ===
LINK_LIBRARIES(minc_io)

ADD_EXECUTABLE(trilinear_resample trilinear_resample.cpp)
ADD_EXECUTABLE(volume_avg volume_avg.cpp)
ADD_EXECUTABLE(volume_msq_dist volume_msq_dist.cpp)
ADD_EXECUTABLE(create_grid_file create_grid_file.cpp)

=== debian/changelog ===
libminc (2.4.06-3) unstable; urgency=medium

  * [2159d0a] Code fixes to allow building with GCC 15.
    Closes: #1097231.
  * [55b7170] Renumber patches.
  * [345008c] Harmonize all patch files to end with ".patch".

 -- Steve M. Robbins <smr@debian.org>  Thu, 04 Sep 2025 22:00:47 -0500

libminc (2.4.06-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062418

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 14:12:12 +0000

libminc (2.4.06-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [1e0e1ad] Remove non-functional autopkg tests.

 -- Steve M. Robbins <smr@debian.org>  Sat, 30 Dec 2023 10:21:51 -0600

libminc (2.4.06-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [df041f5] New upstream version 2.4.06

 -- Steve M. Robbins <smr@debian.org>  Thu, 21 Dec 2023 21:44:20 -0600

libminc (2.4.05-5) UNRELEASED; urgency=medium

  [ Achu Luma ]
  * Team upload.
  * Added autopkgtest

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

  [ Achu Luma ]
  * [40b149e] Fix type

 -- Achu Luma <ach.lumap@gmail.com>  Mon, 16 Oct 2023 21:24:27 +0100

=== debian/control ===
--- 
+++ 
@@ -4,20 +4,23 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                dh-exec,
                cmake,
                libnetcdf-dev,
                libnifti-dev,
                zlib1g-dev,
                libhdf5-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libminc
 Vcs-Git: https://salsa.debian.org/med-team/libminc.git
 Homepage: https://github.com/BIC-MNI/libminc
 Rules-Requires-Root: no
 
-Package: libminc2-5.3.0
+Package: libminc2-5.3.0t64
+Provides: ${t64:Provides}
+Replaces: libminc2-5.3.0
+Breaks: libminc2-5.3.0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -43,7 +46,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
-         libminc2-5.3.0 (= ${binary:Version}),
+         libminc2-5.3.0t64 (= ${binary:Version}),
          libnetcdf-dev,
          libhdf5-dev
 Conflicts: libminc0-dev

=== debian/watch ===
version=4

opts=uversionmangle=s/-/./g;s/^?(libminc|release)[-.]*// \
   https://github.com/BIC-MNI/libminc/tags .*/?(libminc|release)-(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
